"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

var _ArduinoDevicev2SimpleProperties = _interopRequireDefault(require("./ArduinoDevicev2SimpleProperties"));

var _ArduinoDevicev2Webhook = _interopRequireDefault(require("./ArduinoDevicev2Webhook"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ArduinoDevicev2 model module.
 * @module model/ArduinoDevicev2
 * @version 1.3.2
 */
var ArduinoDevicev2 = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ArduinoDevicev2</code>.
   * ArduinoDevicev2 media type (default view)
   * @alias module:model/ArduinoDevicev2
   * @param href {String} The api reference of this device
   * @param id {String} The arn of the device
   * @param name {String} The friendly name of the device
   * @param serial {String} The serial uuid of the device
   * @param type {String} The type of the device
   * @param userId {String} The id of the user
   */
  function ArduinoDevicev2(href, id, name, serial, type, userId) {
    _classCallCheck(this, ArduinoDevicev2);

    ArduinoDevicev2.initialize(this, href, id, name, serial, type, userId);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ArduinoDevicev2, null, [{
    key: "initialize",
    value: function initialize(obj, href, id, name, serial, type, userId) {
      obj['href'] = href;
      obj['id'] = id;
      obj['name'] = name;
      obj['serial'] = serial;
      obj['type'] = type;
      obj['user_id'] = userId;
    }
    /**
     * Constructs a <code>ArduinoDevicev2</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ArduinoDevicev2} obj Optional instance to populate.
     * @return {module:model/ArduinoDevicev2} The populated <code>ArduinoDevicev2</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ArduinoDevicev2();

        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }

        if (data.hasOwnProperty('events')) {
          obj['events'] = _ApiClient["default"].convertToType(data['events'], [_ArduinoDevicev2SimpleProperties["default"]]);
        }

        if (data.hasOwnProperty('fqbn')) {
          obj['fqbn'] = _ApiClient["default"].convertToType(data['fqbn'], 'String');
        }

        if (data.hasOwnProperty('href')) {
          obj['href'] = _ApiClient["default"].convertToType(data['href'], 'String');
        }

        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }

        if (data.hasOwnProperty('last_activity_at')) {
          obj['last_activity_at'] = _ApiClient["default"].convertToType(data['last_activity_at'], 'Date');
        }

        if (data.hasOwnProperty('metadata')) {
          obj['metadata'] = _ApiClient["default"].convertToType(data['metadata'], {
            'String': Object
          });
        }

        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }

        if (data.hasOwnProperty('serial')) {
          obj['serial'] = _ApiClient["default"].convertToType(data['serial'], 'String');
        }

        if (data.hasOwnProperty('type')) {
          obj['type'] = _ApiClient["default"].convertToType(data['type'], 'String');
        }

        if (data.hasOwnProperty('user_id')) {
          obj['user_id'] = _ApiClient["default"].convertToType(data['user_id'], 'String');
        }

        if (data.hasOwnProperty('webhooks')) {
          obj['webhooks'] = _ApiClient["default"].convertToType(data['webhooks'], [_ArduinoDevicev2Webhook["default"]]);
        }
      }

      return obj;
    }
  }]);

  return ArduinoDevicev2;
}();
/**
 * Creation date of the device
 * @member {Date} created_at
 */


ArduinoDevicev2.prototype['created_at'] = undefined;
/**
 * ArduinoDevicev2SimplePropertiesCollection is the media type for an array of ArduinoDevicev2SimpleProperties (default view)
 * @member {Array.<module:model/ArduinoDevicev2SimpleProperties>} events
 */

ArduinoDevicev2.prototype['events'] = undefined;
/**
 * The fully qualified board name
 * @member {String} fqbn
 */

ArduinoDevicev2.prototype['fqbn'] = undefined;
/**
 * The api reference of this device
 * @member {String} href
 */

ArduinoDevicev2.prototype['href'] = undefined;
/**
 * The arn of the device
 * @member {String} id
 */

ArduinoDevicev2.prototype['id'] = undefined;
/**
 * Last activity date
 * @member {Date} last_activity_at
 */

ArduinoDevicev2.prototype['last_activity_at'] = undefined;
/**
 * The metadata of the device
 * @member {Object.<String, Object>} metadata
 */

ArduinoDevicev2.prototype['metadata'] = undefined;
/**
 * The friendly name of the device
 * @member {String} name
 */

ArduinoDevicev2.prototype['name'] = undefined;
/**
 * The serial uuid of the device
 * @member {String} serial
 */

ArduinoDevicev2.prototype['serial'] = undefined;
/**
 * The type of the device
 * @member {String} type
 */

ArduinoDevicev2.prototype['type'] = undefined;
/**
 * The id of the user
 * @member {String} user_id
 */

ArduinoDevicev2.prototype['user_id'] = undefined;
/**
 * ArduinoDevicev2WebhookCollection is the media type for an array of ArduinoDevicev2Webhook (default view)
 * @member {Array.<module:model/ArduinoDevicev2Webhook>} webhooks
 */

ArduinoDevicev2.prototype['webhooks'] = undefined;
var _default = ArduinoDevicev2;
exports["default"] = _default;