"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

var _ArduinoDevicev2SimpleProperties = _interopRequireDefault(require("./ArduinoDevicev2SimpleProperties"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ArduinoDevicev2EventProperties model module.
 * @module model/ArduinoDevicev2EventProperties
 * @version 1.3.2
 */
var ArduinoDevicev2EventProperties = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ArduinoDevicev2EventProperties</code>.
   * ArduinoDevicev2EventProperties media type (default view)
   * @alias module:model/ArduinoDevicev2EventProperties
   * @param events {Array.<module:model/ArduinoDevicev2SimpleProperties>} ArduinoDevicev2SimplePropertiesCollection is the media type for an array of ArduinoDevicev2SimpleProperties (default view)
   * @param id {String} The device of the property
   */
  function ArduinoDevicev2EventProperties(events, id) {
    _classCallCheck(this, ArduinoDevicev2EventProperties);

    ArduinoDevicev2EventProperties.initialize(this, events, id);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ArduinoDevicev2EventProperties, null, [{
    key: "initialize",
    value: function initialize(obj, events, id) {
      obj['events'] = events;
      obj['id'] = id;
    }
    /**
     * Constructs a <code>ArduinoDevicev2EventProperties</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ArduinoDevicev2EventProperties} obj Optional instance to populate.
     * @return {module:model/ArduinoDevicev2EventProperties} The populated <code>ArduinoDevicev2EventProperties</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ArduinoDevicev2EventProperties();

        if (data.hasOwnProperty('events')) {
          obj['events'] = _ApiClient["default"].convertToType(data['events'], [_ArduinoDevicev2SimpleProperties["default"]]);
        }

        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
      }

      return obj;
    }
  }]);

  return ArduinoDevicev2EventProperties;
}();
/**
 * ArduinoDevicev2SimplePropertiesCollection is the media type for an array of ArduinoDevicev2SimpleProperties (default view)
 * @member {Array.<module:model/ArduinoDevicev2SimpleProperties>} events
 */


ArduinoDevicev2EventProperties.prototype['events'] = undefined;
/**
 * The device of the property
 * @member {String} id
 */

ArduinoDevicev2EventProperties.prototype['id'] = undefined;
var _default = ArduinoDevicev2EventProperties;
exports["default"] = _default;