"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ArduinoDevicev2Pass model module.
 * @module model/ArduinoDevicev2Pass
 * @version 1.3.2
 */
var ArduinoDevicev2Pass = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ArduinoDevicev2Pass</code>.
   * DeviceCertV2 describes a password associated to a device (default view)
   * @alias module:model/ArduinoDevicev2Pass
   * @param set {Boolean} Whether the password is set or not
   */
  function ArduinoDevicev2Pass(set) {
    _classCallCheck(this, ArduinoDevicev2Pass);

    ArduinoDevicev2Pass.initialize(this, set);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ArduinoDevicev2Pass, null, [{
    key: "initialize",
    value: function initialize(obj, set) {
      obj['set'] = set;
    }
    /**
     * Constructs a <code>ArduinoDevicev2Pass</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ArduinoDevicev2Pass} obj Optional instance to populate.
     * @return {module:model/ArduinoDevicev2Pass} The populated <code>ArduinoDevicev2Pass</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ArduinoDevicev2Pass();

        if (data.hasOwnProperty('set')) {
          obj['set'] = _ApiClient["default"].convertToType(data['set'], 'Boolean');
        }

        if (data.hasOwnProperty('suggested_password')) {
          obj['suggested_password'] = _ApiClient["default"].convertToType(data['suggested_password'], 'String');
        }
      }

      return obj;
    }
  }]);

  return ArduinoDevicev2Pass;
}();
/**
 * Whether the password is set or not
 * @member {Boolean} set
 */


ArduinoDevicev2Pass.prototype['set'] = undefined;
/**
 * A random suggested password
 * @member {String} suggested_password
 */

ArduinoDevicev2Pass.prototype['suggested_password'] = undefined;
var _default = ArduinoDevicev2Pass;
exports["default"] = _default;