"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ArduinoDevicev2SimpleProperties model module.
 * @module model/ArduinoDevicev2SimpleProperties
 * @version 1.3.2
 */
var ArduinoDevicev2SimpleProperties = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ArduinoDevicev2SimpleProperties</code>.
   * ArduinoDevicev2SimpleProperties media type (default view)
   * @alias module:model/ArduinoDevicev2SimpleProperties
   * @param name {String} The name of the property
   * @param updatedAt {Date} Update date of the property
   * @param value {Object} Value of the property
   */
  function ArduinoDevicev2SimpleProperties(name, updatedAt, value) {
    _classCallCheck(this, ArduinoDevicev2SimpleProperties);

    ArduinoDevicev2SimpleProperties.initialize(this, name, updatedAt, value);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ArduinoDevicev2SimpleProperties, null, [{
    key: "initialize",
    value: function initialize(obj, name, updatedAt, value) {
      obj['name'] = name;
      obj['updated_at'] = updatedAt;
      obj['value'] = value;
    }
    /**
     * Constructs a <code>ArduinoDevicev2SimpleProperties</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ArduinoDevicev2SimpleProperties} obj Optional instance to populate.
     * @return {module:model/ArduinoDevicev2SimpleProperties} The populated <code>ArduinoDevicev2SimpleProperties</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ArduinoDevicev2SimpleProperties();

        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }

        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }

        if (data.hasOwnProperty('value')) {
          obj['value'] = _ApiClient["default"].convertToType(data['value'], Object);
        }
      }

      return obj;
    }
  }]);

  return ArduinoDevicev2SimpleProperties;
}();
/**
 * The name of the property
 * @member {String} name
 */


ArduinoDevicev2SimpleProperties.prototype['name'] = undefined;
/**
 * Update date of the property
 * @member {Date} updated_at
 */

ArduinoDevicev2SimpleProperties.prototype['updated_at'] = undefined;
/**
 * Value of the property
 * @member {Object} value
 */

ArduinoDevicev2SimpleProperties.prototype['value'] = undefined;
var _default = ArduinoDevicev2SimpleProperties;
exports["default"] = _default;