"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

var _ArduinoSeriesResponse = _interopRequireDefault(require("./ArduinoSeriesResponse"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ArduinoSeriesBatch model module.
 * @module model/ArduinoSeriesBatch
 * @version 1.3.2
 */
var ArduinoSeriesBatch = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ArduinoSeriesBatch</code>.
   * ArduinoSeriesBatch media type (default view)
   * @alias module:model/ArduinoSeriesBatch
   * @param respVersion {Number} Response version
   * @param responses {Array.<module:model/ArduinoSeriesResponse>} Responses of the request
   */
  function ArduinoSeriesBatch(respVersion, responses) {
    _classCallCheck(this, ArduinoSeriesBatch);

    ArduinoSeriesBatch.initialize(this, respVersion, responses);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ArduinoSeriesBatch, null, [{
    key: "initialize",
    value: function initialize(obj, respVersion, responses) {
      obj['resp_version'] = respVersion;
      obj['responses'] = responses;
    }
    /**
     * Constructs a <code>ArduinoSeriesBatch</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ArduinoSeriesBatch} obj Optional instance to populate.
     * @return {module:model/ArduinoSeriesBatch} The populated <code>ArduinoSeriesBatch</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ArduinoSeriesBatch();

        if (data.hasOwnProperty('resp_version')) {
          obj['resp_version'] = _ApiClient["default"].convertToType(data['resp_version'], 'Number');
        }

        if (data.hasOwnProperty('responses')) {
          obj['responses'] = _ApiClient["default"].convertToType(data['responses'], [_ArduinoSeriesResponse["default"]]);
        }
      }

      return obj;
    }
  }]);

  return ArduinoSeriesBatch;
}();
/**
 * Response version
 * @member {Number} resp_version
 */


ArduinoSeriesBatch.prototype['resp_version'] = undefined;
/**
 * Responses of the request
 * @member {Array.<module:model/ArduinoSeriesResponse>} responses
 */

ArduinoSeriesBatch.prototype['responses'] = undefined;
var _default = ArduinoSeriesBatch;
exports["default"] = _default;