"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

var _ArduinoSeriesRawLastValueResponse = _interopRequireDefault(require("./ArduinoSeriesRawLastValueResponse"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ArduinoSeriesRawBatchLastvalue model module.
 * @module model/ArduinoSeriesRawBatchLastvalue
 * @version 1.3.2
 */
var ArduinoSeriesRawBatchLastvalue = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ArduinoSeriesRawBatchLastvalue</code>.
   * ArduinoSeriesRawBatchLastvalue media type (default view)
   * @alias module:model/ArduinoSeriesRawBatchLastvalue
   * @param responses {Array.<module:model/ArduinoSeriesRawLastValueResponse>} Responses of the request
   * @param status {String} Status of the response
   */
  function ArduinoSeriesRawBatchLastvalue(responses, status) {
    _classCallCheck(this, ArduinoSeriesRawBatchLastvalue);

    ArduinoSeriesRawBatchLastvalue.initialize(this, responses, status);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ArduinoSeriesRawBatchLastvalue, null, [{
    key: "initialize",
    value: function initialize(obj, responses, status) {
      obj['responses'] = responses;
      obj['status'] = status;
    }
    /**
     * Constructs a <code>ArduinoSeriesRawBatchLastvalue</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ArduinoSeriesRawBatchLastvalue} obj Optional instance to populate.
     * @return {module:model/ArduinoSeriesRawBatchLastvalue} The populated <code>ArduinoSeriesRawBatchLastvalue</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ArduinoSeriesRawBatchLastvalue();

        if (data.hasOwnProperty('responses')) {
          obj['responses'] = _ApiClient["default"].convertToType(data['responses'], [_ArduinoSeriesRawLastValueResponse["default"]]);
        }

        if (data.hasOwnProperty('status')) {
          obj['status'] = _ApiClient["default"].convertToType(data['status'], 'String');
        }
      }

      return obj;
    }
  }]);

  return ArduinoSeriesRawBatchLastvalue;
}();
/**
 * Responses of the request
 * @member {Array.<module:model/ArduinoSeriesRawLastValueResponse>} responses
 */


ArduinoSeriesRawBatchLastvalue.prototype['responses'] = undefined;
/**
 * Status of the response
 * @member {String} status
 */

ArduinoSeriesRawBatchLastvalue.prototype['status'] = undefined;
var _default = ArduinoSeriesRawBatchLastvalue;
exports["default"] = _default;