"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

var _BatchQueryRequestMediaV = _interopRequireDefault(require("./BatchQueryRequestMediaV1"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The BatchQueryRequestsMediaV1 model module.
 * @module model/BatchQueryRequestsMediaV1
 * @version 1.3.2
 */
var BatchQueryRequestsMediaV1 = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>BatchQueryRequestsMediaV1</code>.
   * @alias module:model/BatchQueryRequestsMediaV1
   * @param requests {Array.<module:model/BatchQueryRequestMediaV1>} Requests
   * @param respVersion {Number} Response version
   */
  function BatchQueryRequestsMediaV1(requests, respVersion) {
    _classCallCheck(this, BatchQueryRequestsMediaV1);

    BatchQueryRequestsMediaV1.initialize(this, requests, respVersion);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(BatchQueryRequestsMediaV1, null, [{
    key: "initialize",
    value: function initialize(obj, requests, respVersion) {
      obj['requests'] = requests;
      obj['resp_version'] = respVersion;
    }
    /**
     * Constructs a <code>BatchQueryRequestsMediaV1</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BatchQueryRequestsMediaV1} obj Optional instance to populate.
     * @return {module:model/BatchQueryRequestsMediaV1} The populated <code>BatchQueryRequestsMediaV1</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new BatchQueryRequestsMediaV1();

        if (data.hasOwnProperty('requests')) {
          obj['requests'] = _ApiClient["default"].convertToType(data['requests'], [_BatchQueryRequestMediaV["default"]]);
        }

        if (data.hasOwnProperty('resp_version')) {
          obj['resp_version'] = _ApiClient["default"].convertToType(data['resp_version'], 'Number');
        }
      }

      return obj;
    }
  }]);

  return BatchQueryRequestsMediaV1;
}();
/**
 * Requests
 * @member {Array.<module:model/BatchQueryRequestMediaV1>} requests
 */


BatchQueryRequestsMediaV1.prototype['requests'] = undefined;
/**
 * Response version
 * @member {Number} resp_version
 */

BatchQueryRequestsMediaV1.prototype['resp_version'] = undefined;
var _default = BatchQueryRequestsMediaV1;
exports["default"] = _default;