"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The CheckDevicesV2PassPayload model module.
 * @module model/CheckDevicesV2PassPayload
 * @version 1.3.2
 */
var CheckDevicesV2PassPayload = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>CheckDevicesV2PassPayload</code>.
   * @alias module:model/CheckDevicesV2PassPayload
   * @param password {String} The password for the device
   */
  function CheckDevicesV2PassPayload(password) {
    _classCallCheck(this, CheckDevicesV2PassPayload);

    CheckDevicesV2PassPayload.initialize(this, password);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(CheckDevicesV2PassPayload, null, [{
    key: "initialize",
    value: function initialize(obj, password) {
      obj['password'] = password;
    }
    /**
     * Constructs a <code>CheckDevicesV2PassPayload</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/CheckDevicesV2PassPayload} obj Optional instance to populate.
     * @return {module:model/CheckDevicesV2PassPayload} The populated <code>CheckDevicesV2PassPayload</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new CheckDevicesV2PassPayload();

        if (data.hasOwnProperty('password')) {
          obj['password'] = _ApiClient["default"].convertToType(data['password'], 'String');
        }
      }

      return obj;
    }
  }]);

  return CheckDevicesV2PassPayload;
}();
/**
 * The password for the device
 * @member {String} password
 */


CheckDevicesV2PassPayload.prototype['password'] = undefined;
var _default = CheckDevicesV2PassPayload;
exports["default"] = _default;