"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ThingSketch model module.
 * @module model/ThingSketch
 * @version 1.3.2
 */
var ThingSketch = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ThingSketch</code>.
   * ThingSketchPayload describes a sketch of a thing
   * @alias module:model/ThingSketch
   */
  function ThingSketch() {
    _classCallCheck(this, ThingSketch);

    ThingSketch.initialize(this);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ThingSketch, null, [{
    key: "initialize",
    value: function initialize(obj) {}
    /**
     * Constructs a <code>ThingSketch</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ThingSketch} obj Optional instance to populate.
     * @return {module:model/ThingSketch} The populated <code>ThingSketch</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ThingSketch();

        if (data.hasOwnProperty('sketch_version')) {
          obj['sketch_version'] = _ApiClient["default"].convertToType(data['sketch_version'], 'String');
        }
      }

      return obj;
    }
  }]);

  return ThingSketch;
}();
/**
 * The autogenerated sketch version
 * @member {module:model/ThingSketch.SketchVersionEnum} sketch_version
 */


ThingSketch.prototype['sketch_version'] = undefined;
/**
 * Allowed values for the <code>sketch_version</code> property.
 * @enum {String}
 * @readonly
 */

ThingSketch['SketchVersionEnum'] = {
  /**
   * value: "v1"
   * @const
   */
  "v1": "v1",

  /**
   * value: "v2"
   * @const
   */
  "v2": "v2"
};
var _default = ThingSketch;
exports["default"] = _default;