"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The UpdateSketch model module.
 * @module model/UpdateSketch
 * @version 1.3.2
 */
var UpdateSketch = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>UpdateSketch</code>.
   * @alias module:model/UpdateSketch
   */
  function UpdateSketch() {
    _classCallCheck(this, UpdateSketch);

    UpdateSketch.initialize(this);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(UpdateSketch, null, [{
    key: "initialize",
    value: function initialize(obj) {}
    /**
     * Constructs a <code>UpdateSketch</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/UpdateSketch} obj Optional instance to populate.
     * @return {module:model/UpdateSketch} The populated <code>UpdateSketch</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new UpdateSketch();

        if (data.hasOwnProperty('sketch_version')) {
          obj['sketch_version'] = _ApiClient["default"].convertToType(data['sketch_version'], 'String');
        }
      }

      return obj;
    }
  }]);

  return UpdateSketch;
}();
/**
 * The autogenerated sketch version
 * @member {module:model/UpdateSketch.SketchVersionEnum} sketch_version
 */


UpdateSketch.prototype['sketch_version'] = undefined;
/**
 * Allowed values for the <code>sketch_version</code> property.
 * @enum {String}
 * @readonly
 */

UpdateSketch['SketchVersionEnum'] = {
  /**
   * value: "v1"
   * @const
   */
  "v1": "v1",

  /**
   * value: "v2"
   * @const
   */
  "v2": "v2"
};
var _default = UpdateSketch;
exports["default"] = _default;